# This file was auto-generated by Fern from our API Definition.

import typing

import pydantic
from ..core.pydantic_utilities import IS_PYDANTIC_V2, UniversalBaseModel
from .anthropic_integrations import AnthropicIntegrations
from .anthropic_key_auth import AnthropicKeyAuth
from .collaborator import Collaborator


class AnthropicProviderAccount(UniversalBaseModel):
    """
    +label=Anthropic
    +icon=anthropic
    """

    type: typing.Literal["provider-account/anthropic"] = pydantic.Field(default="provider-account/anthropic")
    """
    +value=provider-account/anthropic
    """

    name: str = pydantic.Field()
    """
    +label=Name
    +sort=100
    +usage=The name of the Anthropic provider account
    +message=3 to 32 lower case characters long alphanumeric word, may contain - in between, cannot start with a number
    +uiProps={"disableEdit":true}
    """

    auth_data: AnthropicKeyAuth
    integrations: typing.Optional[typing.List[AnthropicIntegrations]] = pydantic.Field(default=None)
    """
    +label=Integrations
    +sort=300
    +usage=List of integrations that are associated with the Anthropic provider account
    +uiType=IntegrationsGroup
    """

    collaborators: typing.Optional[typing.List[Collaborator]] = pydantic.Field(default=None)
    """
    +label=Collaborators
    +sort=400
    +usage=List of users who have access to this provider account
    +uiType=Collaborators
    """

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(extra="allow")  # type: ignore # Pydantic v2
    else:

        class Config:
            smart_union = True
            extra = pydantic.Extra.allow
