# This file was auto-generated by Fern from our API Definition.

import typing

import pydantic
from ..core.pydantic_utilities import IS_PYDANTIC_V2, UniversalBaseModel
from .aws_region import AwsRegion
from .aws_s3auth_data import AwsS3AuthData


class AwsS3(UniversalBaseModel):
    """
    +label=AWS S3
    +icon=aws-s3
    """

    type: typing.Literal["integration/blob-storage/aws/s3"] = pydantic.Field(default="integration/blob-storage/aws/s3")
    """
    +value=integration/blob-storage/aws/s3
    """

    name: str = pydantic.Field()
    """
    +label=Display Name
    +usage=The name of the integration that will be displayed in the TrueFoundry UI.
    +sort=100
    +message=3 to 32 lower case characters long alphanumeric word, may contain - in between, cannot start with a number
    """

    storage_root: str = pydantic.Field()
    """
    +label=Storage Root
    +usage=The root path of the storage.
    +sort=200
    """

    region: AwsRegion
    auth_data: typing.Optional[AwsS3AuthData] = pydantic.Field(default=None)
    """
    +label=Auth Data
    +usage=Custom authentication data for the integration.
    +sort=400
    """

    authorized_subjects: typing.Optional[typing.List[str]] = pydantic.Field(default=None)
    """
    +label=Access Control
    +usage=List of subjects that are authorized to access this integration. List of user fqn in format <user_type>:<username>.
    +sort=600
    +uiType=AuthorizedSubjects
    """

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(extra="allow")  # type: ignore # Pydantic v2
    else:

        class Config:
            smart_union = True
            extra = pydantic.Extra.allow
