# This file was auto-generated by Fern from our API Definition.

import typing

import pydantic
from ..core.pydantic_utilities import IS_PYDANTIC_V2, UniversalBaseModel
from .azure_o_auth import AzureOAuth


class AzureVault(UniversalBaseModel):
    """
    +label=Azure Vault
    +icon=azure-vault
    """

    type: typing.Literal["integration/secret-store/azure/vault"] = pydantic.Field(
        default="integration/secret-store/azure/vault"
    )
    """
    +value=integration/secret-store/azure/vault
    """

    name: str = pydantic.Field()
    """
    +label=Display Name
    +usage=The name of the integration that will be displayed in the TrueFoundry UI.
    +sort=150
    +message=3 to 32 lower case characters long alphanumeric word, may contain - in between, cannot start with a number
    """

    auth_data: typing.Optional[AzureOAuth] = None
    key_vault_name: str = pydantic.Field()
    """
    +label=Azure Key vault Name
    +usage=Name of key vault name.
    +sort=300
    """

    authorized_subjects: typing.Optional[typing.List[str]] = pydantic.Field(default=None)
    """
    +label=Access Control
    +usage=List of subjects that are authorized to access this integration. List of user fqn in format <user_type>:<username>.
    +sort=400
    +uiType=AuthorizedSubjects
    """

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(extra="allow")  # type: ignore # Pydantic v2
    else:

        class Config:
            smart_union = True
            extra = pydantic.Extra.allow
