# This file was auto-generated by Fern from our API Definition.

import typing

import pydantic
from ..core.pydantic_utilities import IS_PYDANTIC_V2, UniversalBaseModel
from .collaborator import Collaborator
from .mcp_server_integrations import McpServerIntegrations


class McpServerProviderAccount(UniversalBaseModel):
    """
    +label=MCP Server Group
    +icon=puzzle-piece
    """

    type: typing.Literal["provider-account/hosted-mcp-server"] = pydantic.Field(
        default="provider-account/hosted-mcp-server"
    )
    """
    +value=provider-account/hosted-mcp-server
    """

    name: str = pydantic.Field()
    """
    +label=Name
    +sort=100
    +usage=The name of the MCP Server Group.
    +message=3 to 32 lower case characters long alphanumeric word, may contain - in between, cannot start with a number
    +uiProps={"disableEdit":true}
    """

    collaborators: typing.Optional[typing.List[Collaborator]] = pydantic.Field(default=None)
    """
    +label=Access Control
    +sort=200
    +usage=List of users who have access to this MCP Server Group.
    +uiType=Collaborators
    """

    integrations: typing.List[McpServerIntegrations] = pydantic.Field()
    """
    +label=MCP Servers
    +usage=List of MCP Servers, which are part of this MCP Server Group.
    +sort=400
    +uiType=IntegrationsGroup
    """

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(extra="allow")  # type: ignore # Pydantic v2
    else:

        class Config:
            smart_union = True
            extra = pydantic.Extra.allow
