# This file was auto-generated by Fern from our API Definition.

import typing

import pydantic
from ..core.pydantic_utilities import IS_PYDANTIC_V2, UniversalBaseModel


class PagerDutyIntegrationKeyAuth(UniversalBaseModel):
    """
    +label=PagerDuty Credentails
    """

    type: typing.Literal["pagerduty-integration-auth"] = pydantic.Field(default="pagerduty-integration-auth")
    """
    +value=pagerduty-integration-auth
    """

    integration_key: str = pydantic.Field()
    """
    +label=Integration Key
    +sort=100
    +usage=The integration key for the PagerDuty integration
    +uiType=Password
    """

    integration_url: str = pydantic.Field()
    """
    +label=Integration URL
    +sort=200
    +usage=The integration URL for the PagerDuty integration
    +docs=The integration URL for the PagerDuty integration. This is the URL that will be used to send events to PagerDuty. eg. https://events.pagerduty.com/generic/2010-04-15/create_event.json
    +placeholder=https://events.pagerduty.com/generic/2010-04-15/create_event.json
    """

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(extra="allow")  # type: ignore # Pydantic v2
    else:

        class Config:
            smart_union = True
            extra = pydantic.Extra.allow
